// ole_databaseView.h : interface of the COle_databaseView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_OLE_DATABASEVIEW_H__E6D2F990_C77A_11D3_A721_00062937202F__INCLUDED_)
#define AFX_OLE_DATABASEVIEW_H__E6D2F990_C77A_11D3_A721_00062937202F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Oracl.h"
#include "Obound.h"
#include "selecttable.h"
#include "msflexgrid.h"
class COle_databaseView : public CView
{
protected: // create from serialization only
	COle_databaseView();
	DECLARE_DYNCREATE(COle_databaseView)

// Attributes
public:
	COle_databaseDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COle_databaseView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual BOOL DestroyWindow();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~COle_databaseView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(COle_databaseView)
	afx_msg void OnConnect();
	afx_msg void OnUpdateConnect(CCmdUI* pCmdUI);
	afx_msg void OnDisconnect();
	afx_msg void OnUpdateDisconnect(CCmdUI* pCmdUI);
	afx_msg void OnExecutesql();
	afx_msg void OnUpdateExecutesql(CCmdUI* pCmdUI);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSelecttable();
	afx_msg void OnUpdateSelecttable(CCmdUI* pCmdUI);
	afx_msg void OnClearesql();
	afx_msg void OnUpdateClearesql(CCmdUI* pCmdUI);
	afx_msg void OnClearresult();
	afx_msg void OnUpdateClearresult(CCmdUI* pCmdUI);
	afx_msg void OnFileNew();
	afx_msg void OnFileSave();
	afx_msg void OnFileOpen();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:	
	ODatabase odb;
	ODynaset odyn;
	OValue ovalue;
	CRichEditCtrl m_sqledit;	
	CMSFlexGrid m_flexgrid;
};

#ifndef _DEBUG  // debug version in ole_databaseView.cpp
inline COle_databaseDoc* COle_databaseView::GetDocument()
   { return (COle_databaseDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OLE_DATABASEVIEW_H__E6D2F990_C77A_11D3_A721_00062937202F__INCLUDED_)
